%if "%{?dist}" == ""
%{warn:You must define dist when building this package, expected values are .fcN, .elN, .slesN
}
%endif

Name:           dell-hw-indep-repository
Version:        1
Release:        14%{?dist}
Summary:        System-independent repository configuration for http://linux.dell.com/repo/hardware
Group:          System Environment/Base
License:        BSD
URL:            http://linux.dell.com
Source0:        %{name}.repo
Source1:        RPM-GPG-KEY-dell
Source2:        RPM-GPG-KEY-libsmbios
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

Requires(post): grep perl coreutils
Requires(postun): perl

%description
The Dell linux.dell.com/repo/hardware/ repository contains proprietary
and open source applications suitable for Dell systems.  This repository
is divided into system-independent repository containing RPMs which do
not depend on the system model, and a system-specific repository
containing software specific to each dell model.

This RPM contains the configuration for the system-independent
repository.


%prep
%build
%install
rm -rf $RPM_BUILD_ROOT

DIST=%{dist}
# drop leading '.', if present
if [ "${DIST:0:1}" = "." ]; then
    DIST=${DIST:1}
fi

# only supports SLES9/10, and RHEL3/4/5
case "${DIST}" in 
  el4)
  DIST='el4'
  ;;
  el[35])
  DIST='el$releasever'
  ;;
  el*)
  DIST='el$releasever'
  ;;
  sles9)
  DIST='sles9'
  ;;
  sles10)
  DIST='sles10'
  ;;
  sles*)
  DIST='sles$releasever'
  ;;
  *)
  # don't change DIST
  ;;
esac

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/
sed -e "s/%DIST%/${DIST}/g" %{SOURCE0} > $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/%{name}.repo

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/rpm-gpg/


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%{_sysconfdir}/pki/rpm-gpg/*
%config(noreplace) %{_sysconfdir}/yum.repos.d/*


%post
# bootstrap script is responsible for laying down /etc/dell-mirror.cfg 
# before we run.  fixup yum config for mirror mode:
if [ -e /etc/dell-mirror.cfg ]; then
  . /etc/dell-mirror.cfg
  if [ -n "$HARDWARE_REPO_URL" -a -n "$PUBLIC_HARDWARE_REPO_URL" ]; then
    if [ "$PUBLIC_HARDWARE_REPO_URL" != "$HARDWARE_REPO_URL" ]; then
      perl -p -i -e "s|$PUBLIC_HARDWARE_REPO_URL|$HARDWARE_REPO_URL|g;" /etc/yum.repos.d/%{name}.repo
    fi
  fi
  if [ -n "$HARDWARE_SERVER" -a -n "$PUBLIC_HARDWARE_SERVER" ]; then
    if [ "$PUBLIC_HARDWARE_SERVER" != "$HARDWARE_SERVER" ]; then
      perl -p -i -e "s|$PUBLIC_HARDWARE_SERVER|$HARDWARE_SERVER|g;" /etc/yum.repos.d/%{name}.repo
    fi
  fi
fi

FULL_URL=$(grep ^mirrorlist= %{_sysconfdir}/yum.repos.d/%{name}.repo | cut -d= -f2- | head -n1)

# we need to update up2date config here
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ -e ${RHN_SOURCES} ]; then
  if ! grep -q "^#DONT UPDATE %{name}" ${RHN_SOURCES} > /dev/null 2>&1; then
    # remove existing config
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}

    # add updated config unless user specifies not to
    echo "#BEGIN %{name}" >> ${RHN_SOURCES}
    echo "# This block is managed by the %{name} RPM." >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "yum %{name} ${FULL_URL}&redirect=1&redir_path=" >> ${RHN_SOURCES}
    echo "yum-mirror %{name} $FULL_URL" >> ${RHN_SOURCES}
    echo "" >> ${RHN_SOURCES}
    echo "#END %{name}" >> ${RHN_SOURCES}
  fi
fi

# for sles, cannot add rug config here because it crashes zlm.
# have to do it in the bootstrap script


%postun
RHN_SOURCES=/etc/sysconfig/rhn/sources
if [ $1 = 0 ]; then
  # remove up2date config here
  if [ -e $RHN_SOURCES ]; then 
    perl -n -i -e 'print if not /^#BEGIN %{name}/ ... /^#END %{name}/' ${RHN_SOURCES}
  fi
fi	


%changelog
* Wed Jun 20 2007 Michael E Brown <Michael_E_Brown@dell.com> - 1-0
- initial release
